#include <iostream>
#include <string>
#include <cstring>
#include <algorithm>
#include <sstream>

using namespace std;

/**
Napisati funkciju void glas(string& s) koja premješta slova u stringu s tako da
samoglasnici budu ispred suglasnika. Možete pretpostaviti da će se s sastojati samo
od malih slova.
*/
void glas(string& s) {
    int p = 0;
    for (int i = 0; i < s.length(); i++) {
        char c = s[i];
        if (c == 'a' || c == 'e' || c == 'i' || c == 'o' || c == 'u') {
            swap(s[i], s[p]);
            p++;
        }
    }
}

/**
Napisati funkciju ciklicno(string s, string t, int k)
koja provjerava da li se string t moze dobiti ciklicnim pomjeranjem
stringa s za k mjesta ulijevo ili udesno.
*/
void shift_left(string& s) {
    // abcd -> bcda
    char c = s[0];
    int n = s.length();
    for (int i = 1; i < n; i++) {
        s[i-1] = s[i];
    }
    s[n-1] = c;
}
void shift_right(string& s) {
    // abcd -> dabc
    int n = s.length();
    char c = s[n-1];
    for (int i = n-1; i > 0; i--) {
        s[i] = s[i-1];
    }
    s[0] = c;
}
bool ciklicno(string s, string t, int k) {
    if (s.length() != t.length())
        return false;

    string temp = s;
    for (int i = 0; i < k; i++) {
        shift_left(temp);
    }
    if (temp == t)
        return true;

    temp = s;
    for (int i = 0; i < k; i++) {
        shift_right(temp);
    }
    return temp == t;
}

/**
Napisati program koji sa standardnog ulaza učitava string S i transformiše dati string tako
što okrene redosljed svih slova, a ostale karaktere zadrži na postojećim pozicijama.
Napomena: Za maksimalan broj poena nije dozvoljeno koristiti pomoćni string.
*/
bool slovo(char c) {
    return (c >= 'a' && c <= 'z') || (c >= 'A' && c <= 'Z');
}
void okreni() {
    string s;
    //cin >> s;
    getline(cin, s);

    int l = 0;
    int r = s.length()-1;

    while (true) {
        while (l < r && !slovo(s[l]))
            l++;
        while (l < r && !slovo(s[r]))
            r--;
        if (l < r) {
            swap(s[l], s[r]);
            l++;
            r--;
        }
        else {
            break;
        }
    }

    cout << s << endl;
}

/**
IP adresa je jedinstvena oznaka hosta u računarskoj mreži. IP adresa se sastoji
od četiri prirodna broja od 0 do 255 (bez vodećih nula) odvojena tačkama. Primjeri
validnih IP adresa su: “192.168.1.0”, “255.255.0.0”, “0.1.2.201”. Primjeri nevalidnih IP
adresa su: “2.011.255.245”, “192.168.1.312”, “192.168.11”.
Napisati program koji sa standardnog ulaza učitava string koji se sastoji samo od
cifara i koji računa koliko se validnih IP adresa može kreirati dodavanjem tačaka u taj
string. Na primjer, ako je s=”25525511135”, odgovor je 2 (mogu se formirati IP adrese
“255.255.111.35” i “255.255.11.135”). Ako je s=”0000”, odgovor je 1 (adresa
“0.0.0.0”). Ako je s=”101023”, odgovor je 5 (“1.0.10.23”, “1.0.102.3”, “10.1.0.23”,
“10.10.2.3” i “101.0.2.3”).
*/
bool validan(string s) {
    if (s[0] == '0' && s.length() > 1)
        return false;

    // C varijante
    //int br = atoi(s.c_str());

    //int br;
    //sscanf(s.c_str(), "%d", &br);


    // C++ varijante
    //int br = stoi(s);

    int br;
    stringstream ss;
    ss << s;
    ss >> br;

    return br <= 255;
}

int ip_adrese(string s) {
    int cnt = 0;
    int n = s.length();

    for (int i = 0; i <= 2; i++) {
        for (int j = i+1; j <= i+3 && j < n-2; j++) {
            for (int k = j+1; k <= j+3 && k < n-1; k++) {
                string b1 = s.substr(0, i+1);
                string b2 = s.substr(i+1, j-i);
                string b3 = s.substr(j+1, k-j);
                string b4 = s.substr(k+1);

                if (validan(b1) && validan(b2) && validan(b3) && validan(b4)) {
                    cnt++;
                    cout << b1 << "." << b2 << "." << b3 << "." << b4 << endl;
                }
            }
        }
    }

    return cnt;
}

/**
Napisati program koji sa standardnog ulaza ucitava jednu recenicu i koji
stampa svaku rijec u toj recenici u posebnom redu.
*/
void rijeci() {
    string s;
    getline(cin, s);

    int pos = 0;
    while (true) {
        int new_pos = s.find(" ", pos);
        if (new_pos == string::npos) {
            string r = s.substr(pos);
            cout << r << endl;
            break;
        }
        else {
            string r = s.substr(pos, new_pos-pos);
            cout << r << endl;
            pos = new_pos + 1;
        }
    }
}

int main()
{
    string s = "programiranje";
    glas(s);
    cout << s << endl;

    cout << ciklicno("abcdef", "efabcd", 4) << endl;

    //okreni();

    cout << validan("123") << endl;

    int cnt = ip_adrese("101023");
    cout << cnt << endl;

    //rijeci();

    string hex = "abc";
    int n_hex = stoi(hex, NULL, 16);
    cout << n_hex << endl;

    string bin = "101011";
    size_t tmp;
    int n_bin = stoi(bin, &tmp, 2);
    cout << n_bin << " " << tmp << endl;

    return 0;
}
